/* $Id: Hadou.java,v 1.4 2007/08/31 01:14:43 mit Exp $ */
/*  Hadou v1.4 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

public class Hadou extends Applet 
    implements Runnable, AdjustmentListener, ActionListener
{
    private Scrollbar scrH;
    private Button btS;    // stop
    private Button btG;    // go
    private Thread th;
    private Label lH;

    final int N = 50;
    final int M = 50;
    final int Cmax = 1000;
    final double E = .00001;
    final double TF = 1d;

    boolean SW;
    int W;
    int H;
    int CC = 0;
    int CN = 0;
    int F;
    double[][] U;
    double[][] UK;
    double A = Math.pow(TF*N/M, 2);

    Graphics gi;
    Image ig;

    public void init() {
        setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());

        Panel p = new Panel();
        p.setLayout(new GridLayout(1,4,0,0));

        scrH = new Scrollbar(Scrollbar.HORIZONTAL,1,1,1,6);
	p.add(scrH);
	scrH.addAdjustmentListener(this);

	lH = new Label(" 1");
	p.add(lH);

	btG = new Button("Go");
	p.add(btG);
	btG.addActionListener(this);

	btS = new Button("Stop");
	p.add(btS);
	btS.addActionListener(this);

	add(p, "North");

	U = new double[M+1][N+1];
	UK = new double[M+1][N+1];
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
        repaint();
    }
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btS)        // stop
	    SW = true;
	else if (e.getSource() == btG) { // go
	    SW = false;
	    th = null;
	    start();
	}
    }

    public void start() {
	W = getSize().width;
	H = getSize().height;
	ig = createImage(W, H);
        gi = ig.getGraphics();

	if (th == null) {
	    th = new Thread(this);
	    th.start();
	}
    }
    public void run() {
	while(!SW) {
	    try {
		if (CN < M)
		    CC++;
		else if (CN > M)
		    CC--;
		CN++;
		if (CN > (M*2))
		    CN = 0;

		repaint();
		th.sleep(100);
	    } 
	    catch (InterruptedException e) {
		System.out.println(e);
	    }
	}
    }
    public void stop() {
	if (th != null)
	    th = null;
    }

    public void update(Graphics g) {
	paint(g);
    }
    public void paint (Graphics g) {
	paintI();
	g.drawImage(ig, 0, 0, this);
    }
    public void paintI() {
	int hh = H/2;
	int dh = H/3;
	double dw = (W-2)/(double)N;

	gi.setColor(Color.black);
        gi.fillRect(0,0,W,H);

	gi.setColor(Color.blue);
        gi.drawLine(0,hh,W,hh);

	F = scrH.getValue();
	lH.setText(" "+F);
 
	//------------------------------ keisan --------
	double fmn = F*Math.PI/N;
	for (int j = 0; j <= N; j++)
	    U[0][j] = Math.sin(fmn*j);

	for (int j = 1; j < N; j++)
	    U[1][j] = U[0][j]+A*(U[0][j+1]-2*U[0][j]+U[0][j-1])/2;

	for (int i = 0; i < M; i++) {
	    U[i+1][0] = 0;
	    U[i+1][N] = 0;
	}

	int C = 0;
	gi.setColor(Color.green);
	while(C < Cmax) {
	    for (int i = 1; i < M; i++) {
		for (int j = 1; j < N; j++) {
		    UK[i][j] = U[i][j];
		    U[i+1][j] = 2*U[i][j]-U[i-1][j]+
			A*(U[i][j+1]-2*U[i][j]+U[i][j-1]);
		}
	    }

	    double SE = 0d;
	    double SX = 0d;
	    for (int i = 1; i < M; i++) {
		for (int j = 1; j < N; j++) {
		    SE += Math.abs(U[i][j]-UK[i][j]);
		    SX += Math.abs(U[i][j]);
		}
	    }
	    
	    if (C > Cmax) {
		System.out.println("NO ans.");
		break;
	    } 
	    if (SE > (E*SX))
		C++;
	    else
		break;
	}

	for (int j = 0; j <= N; j++)
	    gi.drawOval((int)(dw*j), (int)(hh-U[CC][j]*dh), 1,1); 
    }
}
